'
'	IBM grants you a nonexclusive copyright license to use all programming code 
'	examples from which you can generate similar function tailored to your own 
'	specific needs.
'
'	All sample code is provided by IBM for illustrative purposes only.
'	These examples have not been thoroughly tested under all conditions. IBM, 
'	therefore cannot guarantee or imply reliability, serviceability, or function of 
'	these programs.
'
'	All Programs or code component contained herein are provided to you "AS IS" 
'	without any warranties of any kind.
'	The implied warranties of non-infringement, merchantability and fitness for a 
'	particular purpose are expressly disclaimed.
'
'	 Copyright IBM Corporation 2007, ALL RIGHTS RESERVED.
'

Module Module1
    ' Values
    Public idmObjTypeMultipleValuesAs As Integer = 1066
    Public idmObjTypeObjectSetAs As Integer = 14
    Public idmObjTypePropertyDescriptionsAs As Integer = 1142
    Public idmObjTypeAccessPermissionAs As Integer = 2012
    Public idmObjTypePermissionDescriptionAs As Integer = 1177
    Public idmObjTypeClassDescriptionAs As Integer = 25
    Public idmObjTypePropertyDescriptionAs As Integer = 24
    Public idmObjTypeObjectStoreAs As Integer = 4
    Public idmObjTypeDocumentAs As Integer = 1
    Public idmObjTypeFolderAs As Integer = 2
    Public idmObjTypeVersionSeriesAs As Integer = 1140
    Public idmObjTypeReferentialContainmentRelationshipAs As Integer = 1124
    Public idmObjTypeContentTransferAs As Integer = 1038
    Public idmObjTypeContentReferenceAs As Integer = 1035
    Public idmObjTypeCustomObjectAs As Integer = 15
    Public idmObjTypeTransientAs As Integer = 1137
    Public idmObjTypeClassDefinitionAs As Integer = 1027
    Public idmObjTypePropertyTemplateAs As Integer = 1055
    Public idmObjTypePropertyDefinitionAs As Integer = 1077
    Public idmObjTypeLocalizedStringAs As Integer = 1075
    Public idmObjTypeTableDefinitionAs As Integer = 1135
    Public idmObjTypeColumnDefinitionAs As Integer = 1028
    Public idmObjTypeChoiceListAs As Integer = 1026
    Public idmObjTypeChoiceAs As Integer = 1025
    Public idmObjTypeDynamicReferentialContainmentRelationshipAs As Integer = 1050
    Public idmObjTypeStoragePolicyAs As Integer = 1037
    Public idmObjTypeAnnotationAs As Integer = 3
    Public idmObjTypeEventActionAs As Integer = 1143
    Public idmObjTypeSubscriptionAs As Integer = 1144
    Public idmObjTypeDocumentLifecyclePolicyAs As Integer = 1148
    Public idmObjTypeDocumentStateAs As Integer = 1152
    Public idmObjTypeDocumentLifecycleActionAs As Integer = 1154
    Public idmObjTypeLinkAs As Integer = 1156
    Public idmObjTypeWorkflowDefinitionAs As Integer = 1160
    Public idmObjTypeDocumentClassificationActionAs As Integer = 1161
    Public idmObjTypeXMLPropertyMappingScriptAs As Integer = 1162
    Public idmObjTypeInstanceSubscriptionAs As Integer = 1165
    Public idmObjTypeClassSubscriptionAs As Integer = 1166
    Public idmObjTypeSecurityPolicyAs As Integer = 1170
    Public idmObjTypeSecurityTemplateAs As Integer = 1175
    Public idmObjTypeUserAs As Integer = 2000
    Public idmObjTypeGroupAs As Integer = 2001
    Public idmObjTypeReadOnlyObjectSetAs As Integer = 2002
    Public idmObjTypeComputerAs As Integer = 2003
    Public idmObjTypeEntireNetworkAs As Integer = 2004
    Public idmObjTypeDomainAs As Integer = 2005
    Public idmObjTypeRealmAs As Integer = 2006
    Public idmObjTypeObjectStoreServiceAs As Integer = 2007
    Public idmObjTypeFileStoreAs As Integer = 2008
    Public idmObjTypeCbrEngineTypeAs As Integer = 2009
    Public idmObjTypeContentManagerServiceAs As Integer = 2010
    Public idmObjTypeContentCacheServiceAs As Integer = 2011
    Public idmObjTypePermissionAs As Integer = 2012
    Public idmObjTypeAnyAs As Integer = 0

    '----------------------------------------------------------------
    '	Get property value in string format
    '----------------------------------------------------------------
    Public Function getPropertyValue(ByVal objProp As CEWSI.PropertyType) As String
        If objProp Is Nothing Then
            getPropertyValue = "null"
            Exit Function
        End If

        Dim strValue As String = ""
        Dim objType As Type = objProp.GetType()

        If objType.FullName = "CEWebClientVB.CEWSI.SingletonString" Then
            Dim objString As CEWSI.SingletonString = objProp
            strValue = objString.Value
        ElseIf objType.FullName = "CEWebClientVB.CEWSI.SingletonBoolean" Then
            Dim objBoolean As CEWSI.SingletonBoolean = objProp
            strValue = objBoolean.Value.ToString()
        ElseIf objType.FullName = "CEWebClientVB.CEWSI.SingletonDateTime" Then
            Dim objDate As CEWSI.SingletonDateTime = objProp
            strValue = objDate.Value.ToString()
        ElseIf objType.FullName = "CEWebClientVB.CEWSI.SingletonFloat64" Then
            Dim objFloat As CEWSI.SingletonFloat64 = objProp
            strValue = objFloat.Value.ToString()
        ElseIf objType.FullName = "CEWebClientVB.CEWSI.SingletonId" Then
            Dim objId As CEWSI.SingletonId = objProp
            strValue = objId.Value
        ElseIf objType.FullName = "CEWebClientVB.CEWSI.SingletonInteger32" Then
            Dim objInt As CEWSI.SingletonInteger32 = objProp
            strValue = objInt.Value.ToString()
        ElseIf objType.FullName = "CEWebClientVB.CEWSI.SingletonObject" Then
            Dim objSO As CEWSI.SingletonObject = objProp

            If objSO.Value Is Nothing Then
                strValue = "null"
            Else
                Try
                    Dim objRef As CEWSI.ObjectReference
                    objRef = objSO.Value
                    strValue = objRef.objectId.ToString()

                Catch E1 As Exception

                    Dim strGarbage As String
                    strGarbage = E1.Message
                    strValue = "Unevaluated"
                End Try
            End If
        ElseIf objType.FullName = "CEWebClientVB.CEWSI.EnumOfObject" Then
            strValue = "Object - unevaluated"
        ElseIf objType.FullName = "CEWebClientVB.CEWSI.ListOfString" Then
            strValue = "List of Strings - unevaluated"
        ElseIf objType.FullName = "CEWebClientVB.CEWSI.ListOfObject" Then
            strValue = "List of Object - unevaluated"
        Else
            strValue = objProp.ToString()
        End If
        getPropertyValue = strValue
    End Function
End Module
